C     WARNING !! test only !! version of spline included !!


      program testantip
c      subroutine testantip

      real*8    conh,pi
      parameter(conh=299792.4562d0,pi=3.14159265359d0)
c      parameter(conh=300000.0d0,pi=3.14159265359d0)

      parameter(mxcurve=300)
      real*4   om_0(mxcurve),cc_0(mxcurve)

      parameter(mxantip=10) ! as of 27/10/99 only one 1/2 antip found
      real*4     antip(mxcurve,mxcurve,mxantip)
      integer*4  nantip(mxcurve,mxcurve)

      logical*4  dosaini

      logical*4  dogam
      parameter(mxgam=8) ! test pour comparer avec Gary Mamon !
      real*4   omgam(mxgam),ccgam(mxgam)
      real*8   chi1d,chi2d,p1d,p2d
      real*8   vec1(4),vec2(4), th1d,th2d, r1d,r2d,  rcurv
      real*8   wminkfn,angle4D8
      external wminkfn,angle4D8

      

      data  omgam/4*0.3,2*1.0,1.0, 0.275/
      data  ccgam/0.0,0.699,0.7,0.701,0.0,1.0,0.0, 0.950/

c     ==== vrifier les calculs de Gary ====
      dogam=.true. !.false. !
      if(dogam)then
         tol=1e-4
         H_0=100.0
         do i=1,mxgam
            if(i.le.6)then
               z1=2.0
               z2=2.05
            else
               z1=0.0
               z2=3.0
            endif
            
            print*,'-------------------------------'
            print*,'i=',i
            q_0 = omgam(i)/2.0 - ccgam(i)

            icc=1
            iom=1
            call antipinit(q_0,H_0,ccgam(i),
     _           antip(icc,iom,1),nantip(icc,iom))

            curv_0= omgam(i)+ccgam(i) -1.0 
            if(curv_0.gt.tol)then
               kcurv=1
               rcurv=conh/H_0 /sqrt(curv_0)
            elseif(curv_0.lt.-tol)then
               kcurv=-1
               rcurv=conh/H_0 /sqrt(-curv_0)
            else
               kcurv=0
               rcurv=1.0d0 !! rcurv units unusable
            endif
            print*,'kcurv,q_0,curv_0,rcurv=',kcurv,q_0,curv_0,rcurv

            chi1d=pdWein(q_0,H_0,ccgam(i), z1)/rcurv
            chi2d=pdWein(q_0,H_0,ccgam(i), z2)/rcurv
            th1d=0.0d0
            th2d=1.0d0*pi/180.0d0
            if(kcurv.lt.0)then
               p1d=sinh(chi1d)
               vec1(4)=cosh(chi1d)
            elseif(kcurv.gt.0)then
               p1d=sin(chi1d)
               vec1(4)=cos(chi1d)
            else
               p1d=chi1d
               vec1(4)=0.0d0
            endif
                  
            print*,'p1,p2,th2d=',p1,p2,th2d
            vec1(1)=p1d
            vec1(2)=0.0d0
            vec1(3)=0.0d0
c            vec1(4)=wminkfn(kcurv, vec1(1),vec1(2),vec1(3))


            if(kcurv.lt.0)then
               p2d=sinh(chi2d)
               vec2(4)=cosh(chi2d)
            elseif(kcurv.gt.0)then
               p2d=sin(chi2d)
               vec2(4)=cos(chi2d)
            else
               p2d=chi2d
               vec2(4)=0.0d0
            endif
            vec2(1)=p2d    *cos(th1d)
            vec2(2)=p2d    *sin(th1d)
            vec2(3)=0.0d0
c            vec2(4)=wminkfn(kcurv, vec2(1),vec2(2),vec2(3))
            

            r1d= angle4D8(kcurv,vec1(4), vec1(1), vec1(2),vec1(3),
     _           vec2(4),vec2(1), vec2(2),vec2(3) )
            if(kcurv.ne.0)r1d=r1d*rcurv

            if(kcurv.lt.0)then
               p2d=sinh(chi2d)
               vec2(4)=cosh(chi2d)
            elseif(kcurv.gt.0)then
               p2d=sin(chi2d)
               vec2(4)=cos(chi2d)
            else
               p2d=chi2d
               vec2(4)=0.0d0
            endif

            vec2(1)=p2d *cos(th2d)
            vec2(2)=p2d *sin(th2d)
            vec2(3)=0.0d0
c            vec2(4)=wminkfn(kcurv, vec2(1),vec2(2),vec2(3))
            r2d= angle4D8(kcurv, vec1(4),vec1(1), vec1(2),vec1(3),
     _           vec2(4),vec2(1), vec2(2),vec2(3) )
            if(kcurv.ne.0)r2d=r2d*rcurv

            
            write(6,'(a,2f6.2,f5.1,f8.3,f10.3,f10.3)')
     _           'gam ',z1,z2,omgam(i),ccgam(i),
     _           r1d,r2d
            print*,' '
         enddo                  !     do i=1,mxgam

         stop
      endif ! if(dogam)

c     ==== check for antipodes, in cases of big \Omega_0, \lambda_0 ====

c     units = Mpc

c     Note that cc_0 = \lambda_0 (cosm. const.) ====

      om1=0.0
      om2=1.1! 2.0 !2.0 !
      cc1=-0.1 !-1.0 !
      cc2= 1.0!2.0!

c      om1=0.32
c      om2=0.3
c      cc1=0.93
c      cc2=1.0

      nom=10 !50 !300 !
      ncc=10 !50 !30 !
      H_0=100.0 
      
C     - test Tarun's formulae --
      dosaini=.false.
      if(dosaini)then

c     write(6,'(a,$)')'Enter  z,gmin: '
c     read(5,*)z,gmin
c     print*,'z,gmin =',z,gmin
c     xx=1.0+z

         write(6,'(a,$)')'Enter  om1,cc1: '
         read(5,*)om1,cc1
         print*,'om1,cc1=',om1,cc1
         xx=2.0/3.0 *(om1+cc1-1.0)/om1
         gmin= ( (-xx*xx*xx + 3.0*xx -2.0) *om1 +2.0 ) /2.0
         print*,'xx,z=xx-1.0,gmin=',xx,xx-1.0,gmin

c     om1= om_gmin(xx,gmin)
c     cc1= cc_gmin(xx,gmin)

         q_0 = om1/2.0 - cc1
         print*,'q_0,om1,cc1=',q_0,om1,cc1

         icc=1
         iom=1
         call antipinit(q_0,H_0,cc1,
     _        antip(icc,iom,1),nantip(icc,iom))
         
         stop 'test'
      endif


      if(nom.gt.1)then
         dom=real(om2-om1)/real(nom-1)
      else
         dom=-99.9
      endif
      if(ncc.gt.1)then
         dcc=real(cc2-cc1)/real(ncc-1)
      else
         dcc=-99.9
      endif
      print*,'dom,dcc=',dom,dcc

      do iom=1,nom
         om_0(iom)= om1+real(iom-1)*dom
         do icc=1,ncc
c         do icc=1,1
            cc_0(icc)= cc1+real(icc-1)*dcc
            q_0= om_0(iom)/2.0 - cc_0(icc)
            
c            if(om_0(iom)+cc_0(icc).le.1.0)then
               call antipinit(q_0,H_0,cc_0(icc),
     _           antip(icc,iom,1),nantip(icc,iom))

c            endif
c            print*,iom,icc,'-----------------------------------------'
         enddo

c         if( nom*( (10*iom)/nom ).eq.10*iom )then
c            print*,'iom=',iom
c         endif

      enddo

      end


      real*4  function ccom_a(om_0,x)
C     ==== formula kindly provided by Tarun (saini@iucaa.ernet.in) 02/12/99,
C     for relating  om_0,cc_0 and antipode redshifts.
C     
C     Original form:
C     cc_0 = ( -x*x*x - gmin*(2.0-3.0*x) )/
C     _     (-x*x*x +3.0*x -2.0)
C     om_0 = ( 2.0*gmin -2.0 )/
C     _     (-x*x*x +3.0*x -2.0)
C     
C     x = 1+z,  xmin=1+zmin, zmin is the redshift whose h(z) has 
C     a minimum value g(z)

      ccom_a = ( -x*x*x - (2.0-3.0*x) )/
     _     (-x*x*x +3.0*x -2.0)
     _     - (2.0-3.0*x)/2.0 * om_0
      
      return
      end

      real*4 function cc_gmin(x,gmin)
C     ==== x=1+z, gmin= minimum of  h(z)
      cc_gmin = ( -x*x*x - gmin*(2.0-3.0*x) )/
     _     (-x*x*x +3.0*x -2.0)
      return
      end

      real*4 function om_gmin(x,gmin)
C     ==== x=1+z, gmin= minimum of  h(z)
      om_gmin = ( 2.0*gmin -2.0 )/
     _     (-x*x*x +3.0*x -2.0)
      return
      end



      subroutine antipinit(q_0,H_0,cc_0,antip,nantip)
c     ---- initialises table of integration for values of t ----
c     WARNING: propd2  is for the  proper motion distance 
c     (terminology Weinberg 1972), not the proper distance

c     Brief description: a table is set up for each choice
c     of metric parameters, with a high number of points from
c     which to interpolate later on when called by either
c     propd2  or  zofpd2 . Because the resolution is high 
c     to minimise numerical effects (no subtle applied maths
c     is used, this is just first principles integration - 
c     divide into equal intervals, and add up the histogram),
c     only a small number of  metric  choices is kept at a time.
c
c     So this algorithm is OK if you test a small number of
c     sets of  metric  parameters, but _inefficient_ if you 
c     want to plot, say, luminosity distance as a function
c     of \Omega_0, for 10000 different values of \Omega_0, 
c     and keeping  z  fixed - unless you set maxpar=10000
c     and reduce  maxn. In that case you should put in a 
c     better integration algorithm.

c     units = Mpc

C     INPUTS:
      real*4     q_0,H_0,cc_0

C     OUTPUTS:
      parameter(mxantip=10)
      real*4     antip(mxantip) ! as of 27/10/99 only 1 1/2 antip found
      integer*4  nantip

      parameter(maxn=100000,maxpar=3)     
c     RANGE OF VALIDITY ! seems good to ~0.01% for z <= 1000.0

      real*4     aa(maxn,maxpar), propd(maxn,maxpar)
      real*4     dpropd(maxn,maxpar)
      real*4     aaB(maxn,maxpar),propdB(maxn,maxpar)
      real*4     daa(maxn,maxpar)

      real*8     aa8(maxn,maxpar), propd8(maxn,maxpar)
      real*8     dpropd8(maxn,maxpar)
      real*8     aaB8(maxn,maxpar),propdB8(maxn,maxpar)
      real*8     daa8(maxn,maxpar)

      real*4     par(3,maxpar)
      integer*4  nzcalc,npar, ipar
      
      real*8     aamax,aamin
      real*8     kapp0,om0,cc_0d, dacalc, factor, adub, pd, zero
      real*8     theint
      real*8     pi ! added BFR 26/10/99
      parameter(pi=3.1415926535897932384626) ! added BFR 26/10/99

      logical    verbose

c      common  /propd2comm/ aa,propd,dpropd,daa, nzcalc,par,ipar,npar,
c     _     aaB,propdB

      verbose=.true. !.false. !

      ipar=1 !! differs from propd2init

      if(verbose)print*,'ipar=',ipar

c     ---- 
      aamin=0.000002d0 !0.001 !0.00001 ! 0.001!
      aamax=1.0d0 
      if(verbose)print*,'propd2init: LIMITS are: aamin,aamax=',
     _     aamin,aamax

c     ---- h_conv = 1 kms^-1 Mpc^-1 * 3.1558e16 s Gyr^-1, 
c     i.e. converts conventional H_0 units to inverse Gigayears ----
      sec_Gyr= 3.1558e16        ! seconds per Gigayear
      akm_Mpc= 3.086e19   ! km per Megaparsec
      akG_sM = akm_Mpc/sec_Gyr ! km Gyr per sec Mpc

c     h_conv=1.024e-3  ! not used
      c=299792.4562
      
      zero=  1.0d-5 !-99.9  ! test only 

      if(verbose)print*,'propd2init: q_0,H_0,cc_0=',q_0,H_0,cc_0
      nzcalc= maxn/10
c      print*,'nzcalc=',nzcalc
c      write(6,'(a,$)')'Enter nzcalc: '
c      read(5,*)nzcalc
      if(verbose)print*,'nzcalc=',nzcalc

      dacalc=(aamax-aamin)/dble(nzcalc)
       if(verbose)print*,'dacalc=',dacalc
      theint=0.0d0
      cc_0d=dble(cc_0)
      om0= 2.0d0*(dble(q_0)+cc_0d)
      kapp0= om0 + cc_0d -1.0d0
      if(abs(kapp0).lt.zero)then
         factor=1.0d0
      else
         factor= sqrt(abs(kapp0))
      endif
       if(verbose)print*,'propd2init: om0,kapp0,factor=',
     _     om0,kapp0,factor
       if(verbose)print*,'cc_0d=',cc_0d

       nantip=0

      do izcalc=nzcalc,1,-1
         adub= aamin+dacalc*(dble(izcalc  )-0.5d0)
         aa8(izcalc,ipar)= adub -dacalc*0.5d0 
         aa(izcalc,ipar)=real( adub -dacalc*0.5d0 )

c         if(verbose)then
c            if(500*(izcalc/500).eq.izcalc)then
c               print*,'aa(izcalc,ipar)=',aa(izcalc,ipar)
c            endif
c         endif

         if(om0/adub -kapp0 +cc_0d*adub*adub .le.0.0)then
             print*,'propd2init Warning: '
             print*,om0/adub -kapp0 +cc_0d*adub*adub,' <= 0.'
             print*,'om0,cc_0d,kapp0,adub=',om0,cc_0d,kapp0,adub
             print*,'izcalc,aa(izcalc,ipar),1.0/aa-1='
             print*,izcalc,aa(izcalc,ipar),
     _            1.0/aa(izcalc,ipar)-1.0
         endif

         theint=theint+ 1.0/adub 
     _        /sqrt( om0/adub -kapp0 +cc_0d*adub*adub )
         pd =dacalc* theint           

         if(abs(kapp0).lt.zero)then
            propd(izcalc,ipar)= real( pd *c/H_0 )
            propd8(izcalc,ipar)= pd *c/H_0 
         elseif(kapp0.le.-zero)then
            propd(izcalc,ipar)= sinh(factor*pd)/factor *c/H_0
            propd8(izcalc,ipar)= sinh(factor*pd)/factor *dble(c/H_0)
         else             ! if(kapp0.ge.zero)then
            propd(izcalc,ipar)= sin(factor*pd)/factor *c/H_0
            propd8(izcalc,ipar)= sin(factor*pd)/factor *dble(c/H_0)

            nn= 2*int( (2.0*factor*pd/pi +1.0)/2.0 )  !! BFR 26/10/99
c            if(nn.gt.0)print*,'izcalc,nn=',izcalc,nn

c            if(2*(nn/2).eq.nn)then
c               propd(izcalc,ipar)= (real(nn)+sin(factor*pd))
c     _              /factor *c/H_0
c            else
c               propd(izcalc,ipar)= (real(nn)-sin(factor*pd))
c     _              /factor *c/H_0
c            endif

            toler=1e-7

            if(factor*pd.ge.pi/2.0*dble(nantip+1))then
               if(abs(aa(izcalc,ipar)).lt.toler)then
                  zz=9e9
               else
                  zz=1.0/aa(izcalc,ipar)-1.0
               endif
               if(verbose)then
                  print*,'Found a half-antipode'
                  print*,'izcalc,aa(izcalc,ipar),1.0/aa-1='
                  print*,'factor*pd=',factor*pd

                  write(6,'(a,5f12.4)')
     _                 'antip:',real(om0),cc_0, factor*pd,
C     _                 izcalc,
     _                 aa(izcalc,ipar),
     _                 zz
               endif
               nantip=nantip+1
               if(nantip.gt.mxantip)then
                  print*,'antipinit WARNING nantip=',nantip
               else
                  antip(nantip)= zz !1.0/aa(izcalc,ipar)-1.0
               endif

            endif

         endif
      enddo

      tol2=1e-4 !1e-6 !
      call spline(aa(1,ipar),propd(1,ipar),nzcalc,0.0,0.0,
     _     dpropd(1,ipar))
      do i=1,nzcalc
         aaB8(i,ipar)=aa8(nzcalc+1-i,ipar)
         propdB8(i,ipar)=propd8(nzcalc+1-i,ipar)
         aaB(i,ipar)=aa(nzcalc+1-i,ipar)
         propdB(i,ipar)=propd(nzcalc+1-i,ipar)
c         if(1+1.eq.3)then
         if(i.gt.1)then
            if( abs(propdB(i,ipar)-propdB(i-1,ipar)).lt.tol2)then
               print*,'antipinit warning: i-1,i,ipar=',i-1,i,ipar
               print*,propdB(i-1,ipar),propdB(i,ipar),tol2
            endif
         endif
      enddo

c      call spline(propdB(1,ipar),aaB(1,ipar),nzcalc,0.0,0.0, ! for inverse
c     _     daa(1,ipar))
      call splne8(propdB8(1,ipar),aaB8(1,ipar),nzcalc,0.0,0.0, ! for inverse
     _     daa8(1,ipar))

      do i=1,nzcalc
         daa(i,ipar)=real(daa8(i,ipar))
      enddo

c     ---- for testing....----
      jj=nzcalc/10
       if(verbose)print*,'jj=',jj
       if(verbose)print*,'(propd(jj*i+1,ipar),i=0,9)'
       if(verbose)print*,(propd(jj*i+1,ipar),i=0,9)
       if(verbose)print*,'(dpropd(jj*i,ipar),i=1,10)'
       if(verbose)print*,(dpropd(jj*i,ipar),i=1,10)
       if(verbose)print*,'(daa(jj*i,ipar),i=1,10)'
       if(verbose)print*,(daa(jj*i,ipar),i=1,10)
       if(verbose)print*,'(aa(jj*i,ipar),propd(jj*i,ipar),i=1,10)'
       if(verbose)print*,(aa(jj*i,ipar),propd(jj*i,ipar),i=1,10)

      return
      end



      SUBROUTINE SPLINE8_test(X,Y,N,YP1,YPN,Y2)  !! test only !!
      PARAMETER (NMAX=100000,toler=1e-5)
c      DIMENSION X(N),Y(N),Y2(N),U(NMAX)
      real*8   x(*),y(*),y2(*),u(nmax)
c      DIMENSION X(*),Y(*),Y2(*),U(NMAX)

      parameter(bignum=.99e30)

      IF (YP1.GT..99E30) THEN
        Y2(1)=0.
        U(1)=0.
      ELSE
        Y2(1)=-0.5

        if(abs(x(2)-x(1)).lt.toler)print*,'spline: ',
     _       'x(2),x(1),x(2)-x(1)=',
     _       x(2),x(1),x(2)-x(1)
        U(1)=(3./(X(2)-X(1))) * ( (Y(2)-Y(1))/(X(2)-X(1)) -YP1 )
        
      ENDIF
      DO 11 I=2,N-1
        SIG=(X(I)-X(I-1))/(X(I+1)-X(I-1))
        P=SIG*Y2(I-1)+2.

        Y2(I)=(SIG-1.)/P
        if(abs(p).lt.toler)print*,'spline: p=',p

        U(I)=(6.*((Y(I+1)-Y(I))/(X(I+1)-X(I))-(Y(I)-Y(I-1))
     *      /(X(I)-X(I-1)))/(X(I+1)-X(I-1))-SIG*U(I-1))/P
11    CONTINUE
      IF (YPN.GT..99E30) THEN
        QN=0.
        UN=0.
      ELSE
        QN=0.5
        UN=(3./(X(N)-X(N-1)))*(YPN-(Y(N)-Y(N-1))/(X(N)-X(N-1)))
      ENDIF

      Y2(N)=(UN-QN*U(N-1))/(QN*Y2(N-1)+1.)
      if(abs(qn*y2(n-1)+1.).lt.toler)print*,
     _     'spline: qn*y2(n-1)+1.=',qn*y2(n-1)+1.
      print*,'spline: y2(n)=',y2(n)

      DO 12 K=N-1,1,-1

        Y2(K)=Y2(K)*Y2(K+1)+U(K)
c        if(abs(y2(k+1)).t.toler .or. abs(u(k)).lt.toler)
        if(.not.(-bignum.lt.y2(k+1).and.y2(k+1).lt.bignum))
     _       print*,'spline: k,y2(k+1),u(k)=',k,y2(k+1),u(k)

12    CONTINUE
      RETURN
      END



      real*8 function wminkfn(kcurv,x,y,z)
C     !!! copied from holon.f 09/12/99  !!!

C     ==== w coordinate in Minkowski or Euclidean 4-space ====
      integer*4  kcurv
      real*8 x,y,z
C     INTERNAL:
      real*8 dd,toler
      parameter(toler=1e-8)

      if(kcurv.lt.0)then
         wminkfn=sqrt(1.0d0+ x*x+y*y+z*z)
      elseif(kcurv.gt.0)then
         dd= 1.0d0- (x*x+y*y+z*z)
         if(dd.lt.toler)then
            wminkfn=sqrt(toler)
            if(dd.lt.-toler)then
               print*,'wminkfn Warning: dd,toler=',dd,toler
            endif
         else
            wminkfn=sqrt(dd)
         endif
      endif
C     -- wminkfn undefined if kcurv.eq.0 --

      return
      end
