      program cdm
c     ==== plots CDM power spectrum |\delta(k)|^2  =======

      parameter(nk=30)
      real*4      p(nk),k(nk),logk(nk),lamb(nk),loglamb(nk)
      real*4      a,alpha, beta, gamma, ell
      real*4      omega0,h,theta
      real*4      dmin,dmax, kmax,kmin, dminl, dmaxl, kmaxl, kminl


      parameter(pi=3.1415926536)


      theta=2.735/2.7
      write(6,'(a,$)')'Enter Omega_0, h: '
      read(5,*)omega0,h
      ell= 1.0/ (omega0*h*h /theta/theta)
      alpha=1.7 *ell
      beta= 9.0 *ell *sqrt(ell)
      gamma= 1.0*ell*ell
      print*,'ell, alpha, beta, gamma  are:'
      print*,ell, alpha, beta, gamma  
      
      print*,'amplitude left at  A=1'
      a=1

      write(6,'(a,$)')'Enter min lambda, max lambda in Mpc: '
      read(5,*)dmin,dmax

      dminl=log10(dmin)
      dmaxl=log10(dmax)
      kmin=2.0*pi /dmax
      kmax=2.0*pi /dmin
      kminl=log10(kmin)
      kmaxl=log10(kmax)
      pmin=-10.0
      pmax=0.0
      ptoptex=-1.2

      delk= (kmaxl-kminl) /real(nk)
      do i=1,nk
         logk(i)= kminl + (real(i)-0.5)*delk
         k(i)=exp(log(10.0)*logk(i))
         p(i)=1.0 +alpha*k(i) + beta*k(i)*sqrt(k(i)) +gamma*k(i)*k(i)
         p(i)=a * k(i) /p(i) /p(i)
         p(i)=log10(p(i))
      enddo
      print*,'k(i)=',k
      

      call pgiapbegin(0,'?',1,1)
      call pgwindow(kminl,kmaxl,pmin,pmax)
      call pgbox('bntsl',0.0,0,'bcntsv',0.0,0)

      call pglabel('wavenumber  k in Mpc\\u-1\\d',
     _     ' log\\d10\\u |\\gd\\dk\\u|\\u2\\d', 
     _     'wavelength in Mpc')
      call pgtext(kminl+ delk, ptoptex, 
     _     ' CDM  power spectrum, Davis et al., 1985')

      if((omega0.eq.1.0).and.(h.eq.0.5))
     -     call pgtext(0.0,-3.0,
     _     '\\gW\\d0\\u=1.0, h=0.5')

      call pgline(nk,logk,p)

      call pgwindow(dmaxl,dminl,pmin,pmax)
      call pgbox('cmtsl',0.0,0,' ',0.0,0)

      call pgiden
      call pgend

      end
