c      program dVdz_test
      subroutine dVdz_test
c     ==== calls  dVdz ====

c      implicit integer*4(i,j,k,l,m,n), real*4(a-h,o-z)

      parameter(nq0=4)
      real   x(30,nq0),q_0(nq0),x1(30),zlog(30),zlin(30)
      real   xlowz(30)
      character*40   label(nq0)

c      print*,'q_0, H_0 (in kms^-1 Mpc^-1), z ?'
c      read(5,*)q_0,H_0,z
c      x=dVdz(q_0,H_0,z)
c      print*,'dVdz=',x

      H_0=50.0

      q_0(1)=0.05
      q_0(2)=0.2
      q_0(3)=0.5
c     q_0(4)=1.0
      q_0(4)=0.0
      label(1)='q\\d0\\u=0\\(0729)05'
      label(2)='q\\d0\\u=0\\(0729)2'
      label(3)='q\\d0\\u=0\\(0729)5'
c      label(4)='q\\d0\\u=1\\(0729)0'
      label(4)='q\\d0\\u=0\\(0729)0'


      cH3=(3.0e5/H_0)*(3.0e5/H_0)*(3.0e5/H_0)
      pi=3.1415926539
      V0=cH3 * pi*pi/180.0/180.0

      xmax=0.0
      write(6,'(a,$)')'Enter  zmax: '
      read(5,*)zmax

      do i=1,nq0
         do j=1,30
c           ---- log ----
c            zlog(j)=(-1.0 + (real(j)-0.5)/15.0 )
c            z=exp( log(10.0)*zlog(j)) 
c           ---- linear ----
           
            zlin(j)= (real(j)-0.5) *zmax/30
            z=zlin(j)

            z3=(1.0+z)*(1.0+z)*(1.0+z)
            x(j,i)=dVdz(q_0(i),50.0,z) *z3
c           ---- dV/d(ln z)= dV/ (1/z *dz) = z* dV/dz
c            x(j,i)=x(j,i) *z

            xlowz(j)=V0 *z*z 
c                        *z3
            
            if(x(j,i).gt.xmax)xmax=x(j,i) 
            if(xlowz(j).gt.xmax)xmax=xlowz(j)
         enddo
      enddo

      write(6,'(a,g13.2,a,$)')'xmax=',xmax,'. Enter  xmax: '
      read(5,*)xmax



      call pgbegin(0, '?', 1, 1)
      call pgscf(2)
 
      call pgvsize(1.0, 5.0, 1.0, 4.0)
c      call pgwindow(-1.0,1.0,0.0,xmax)
c      call pgbox('bcntsl',0.,0,'bcnts',0.,0)
c      call pglabel('z','(1+z)\\u3\\d  dV/d(ln z)',
c     _  'Comoving Vol. Element derivative (H\\d0\\u = 50 kms\\u-1\\d)')

      call pgwindow(0.0,zmax,0.0,xmax)
      call pgbox('bcnts',0.,0,'bcnts',0.,0)
      call pglabel('z','(1+z)\\u3\\d  dV/dz', ' ')
c     _  'Comoving Vol. Element derivative (H\\d0\\u = 50 kms\\u-1\\d)')

      
      x0=0.9*xmax
      delx=0.08*xmax
      zz0=zmax/20.0 +zmax/15.0
      zz1=3.0*zmax/20.0 +zmax/15.0
      zz2=3.2*zmax/20.0 +zmax/15.0
      
      do i=1,nq0
         do j=1,30
            x1(j)=x(j,i)
         enddo

c         call pgline(30,zlog,x1)
         call pgsls(i+1)
         call pgline(30,zlin,x1)
         call pgmove(zz0,x0-delx*real(i-1))
         call pgdraw(zz1,x0-delx*real(i-1))
         call pgsls(1)
         call pgtext(zz2,x0-delx*real(i-1)-0.01*xmax,label(i))
      enddo
      i=nq0+1
      call pgsls(1)
      call pgline(30,zlin,xlowz)
c      call pgmove(zz0,x0-delx*real(i-1))
c      call pgdraw(zz1,x0-delx*real(i-1))
c      call pgsls(1)
c      call pgtext(zz2,x0-delx*real(i-1)-0.01*xmax,
c     _     'naive')
      


c      call pgiden
      call pgend

      end
 
      function dVdz(q_0,H_0,z)
c     ==== calculates derivative of volume element per sq. degree,
c     i.e. the rate at which (3-D) spatial volume increases through our 
c     past "time cone" as a function of  z. ====
c     ---- units of H_0 should be kms^-1 Mpc^-1,  
c          dVdz is in units of  Mpc^3 sq.deg.^-1, in proper coords ----
      

      real    dVdz,q_0,H_0,z
 
      c=299792.4562
      pi=3.14159265359
      dl=propdist(q_0,H_0,z) *(1.0+z)
      z6=(1.0+z)*(1.0+z)*(1.0+z)* (1.0+z)*(1.0+z)*(1.0+z)
      dVdz= 4.0*pi*c *dl*dl /H_0 /z6 /sqrt( 1.0 + 2.0*q_0*z )
      dVdz= dVdz /(4.0*pi)  * (pi/180.0) *(pi/180.0)

      return
      end
      
