c      program testd_l2
      subroutine testd_l2
c     - swap between commenting out the above two lines to 
c     use this as a test, standalone programme, or as a routine
c     to be called.

c     ==== these subroutines test, initialise, and 
c     spline-interpolate (via splint) in  the integral
c     to use for calculating  d_L(z)  (luminosity distance) 
c     for arbitrary 
c     q_0, \lambda_0, H_0, z  

c     units = Mpc

c     Note that cc_0 = \lambda_0 (cosm. const.) ====

c     ==== To get the plot, enter a value of q_0 > 99.9 
c     to the prompt (plus any other values for other parameters)
c     (or on a non-linux unix machine, you can use ^D ).
c     You will then be asked to put in some parameters 
c     to make a plot of the angular diameter of a galaxy
c     of fixed proper size displaced at different values
c     of the cosmological scale parameter a = 1/(1+z) .

      parameter(maxnout=5000)
      real*4    a(maxnout),z(maxnout)
      real*4    t1(maxnout),t2(maxnout)
      real*4    dprop1(maxnout),dprop2(maxnout)
      real*4    diff1(maxnout),diff2(maxnout)
      real*4    angdiam(maxnout)

c      real*4    aa(maxn),tt(maxn),dtt(maxn)
      logical   doprint
      parameter(pi=3.1415926536,c=299792.4562)

      do while(1+1.eq.2.and.q_0.le.99.9) ! Enter q_0 .gt. 99.9 to terminate
         print*,'q_0,H_0,cc_0=',q_0,H_0,cc_0
         write(6,'(a,$)')'Enter q_0,H_0,cc_0,zz:' !,ttt: '
         read(5,*,end=555)q_0,H_0,cc_0,zz !,ttt
         if(q_0.le.99.9)then
            print*,'q_0,H_0,cc_0,zz=',q_0,H_0,cc_0,zz
c     print*,'tofz2(q_0,H_0,cc_0,zz), zoft2(q_0,H_0,cc_0,ttt)='
            
c     tt1=tofz2(q_0,H_0,cc_0,zz)
c     zz1= zoft2(q_0,H_0,cc_0,ttt)
c     print*,tt1,zz1
c     print*,tofz2(q_0,H_0,cc_0,zz), zoft2(q_0,H_0,cc_0,ttt)
            xx1=propd2(q_0,H_0,cc_0,zz)
            print*,'propd2(q_0,H_0,cc_0,zz),propd2(.)*(1+zz)='
            print*,xx1,xx1*(1.0+zz)
            rr=2*c/H_0*(1.0-1.0/sqrt(1.0+ zz  )) !12000 Mpc=2c/H_0
            print*,'2*c/H_0*(1-1/sqrt(1+z))=',rr
            print*,'diff= ',rr-xx1
            zz=zofpd2(q_0,H_0,cc_0,xx1)
            print*,'zofpd2(q_0,H_0,cc_0,xx1)=',zz
            print*,' '
         endif
      enddo
 555  continue

c      call tofz2init(q_0,H_0,cc_0)

      zmin=1e-4 ! 0.001
      zmax=100.0
      nzout=3000

      call pgbegin(0,'?',1,1)
      write(6,'(a,$)')'Enter  ang. diam. max (arcsec): '
      read(5,*)admax
      print*,'zmin,zmax,nzout=',zmin,zmax,nzout
      write(6,'(a,$)')'Enter  zmin, zmax: '
      read(5,*)zmin, zmax
      aamin= 1.0/(1.0+zmax)
      print*,'aamin=',aamin
      write(6,'(a,$)')'Enter  aamin: '
      read(5,*)aamin

      dzout=(zmax-zmin)/real(nzout-1)

      do while(1+1.eq.2)
         amax=20.0
         print*,'q_0,H_0,cc_0=',q_0,H_0,cc_0
         write(6,'(a,$)')'Enter new values: '
         read(5,*,end=666)q_0,H_0,cc_0
         
         write(6,'(a,$)')'Enter gal. size (kpc): '
         read(5,*,end=666)gsize

         doprint=.false.

         do izout=1,nzout
            if(doprint)print*,'izout=',izout,'...'
            z(izout)= zmin+ real(izout-1)*dzout
            a(izout)= 1.0/(1.0+z(izout))
            if(doprint)print*,'a(izout),z(izout)=',a(izout),z(izout)
c            t1(izout)=tofz2(q_0,H_0,cc_0,z(izout))

            dprop1(izout)=propd2(q_0,H_0,cc_0,z(izout))

            if(cc_0.eq.0.0)then
c     !!!! following two lines require  d_l.f, tofz.f, for comparison !!!!
c               t2(izout)=tofz(q_0,H_0,z(izout))
c               dprop2(izout)=propdist(q_0,H_0,z(izout))
c               diff1(izout)=t1(izout)/t2(izout)
               diff2(izout)=dprop1(izout)/dprop2(izout)
               if(doprint)print*,'diff1(izout)=',diff1(izout)
               if(doprint)print*,'diff2(izout)=',diff2(izout)
            endif
            angdiam(izout)= gsize /1000.0
     _           / ( propd2(q_0,H_0,cc_0,z(izout)) 
     _           /(1.0+z(izout)) )
     _           /pi *180.0 *3600.0
         enddo

         dpropmax=12000.0
c         admax= 20.0

         call pgsch(0.8)
         call pgscf(2)
         call pgvsize(1.0,6.0,1.0,6.0)
c         call pgwindow(0.0,1.0,0.0,dpropmax)
         call pgwindow(aamin,1.0,0.0,admax)
         call pgbox('bcnts',0.,0,'bcnts',0.,0)
         call pgsch(1.0)
c         call pgline(nzout,a,dprop1)
         call pgline(nzout,a,angdiam)
         call pgsls(4)
c         if(cc_0.eq.0.0)call pgpoint(nzout,a,dprop2,5)
         call pgsls(1)
c         call pglabel('a','d\\dprop','integrations...')
         call pglabel('a','ang. diam (arc sec)','integrations...')

      enddo
 666  continue

      call pgend

      end


      subroutine propd2init(q_0,H_0,cc_0)
c     ---- initialises table of integration for values of t ----
c     WARNING: propd2  is for the  proper motion distance 
c     (terminology Weinberg 1972), not the proper distance

c     Brief description: a table is set up for each choice
c     of metric parameters, with a high number of points from
c     which to interpolate later on when called by either
c     propd2  or  zofpd2 . Because the resolution is high 
c     to minimise numerical effects (no subtle applied maths
c     is used, this is just first principles integration - 
c     divide into equal intervals, and add up the histogram),
c     only a small number of  metric  choices is kept at a time.
c
c     So this algorithm is OK if you test a small number of
c     sets of  metric  parameters, but _inefficient_ if you 
c     want to plot, say, luminosity distance as a function
c     of \Omega_0, for 10000 different values of \Omega_0, 
c     and keeping  z  fixed - unless you set maxpar=10000
c     and reduce  maxn. In that case you should put in a 
c     better integration algorithm.

c     units = Mpc

      real*4     q_0,H_0,cc_0
c      parameter(maxn=100000,maxpar=3)     
      parameter(maxn=10000,maxpar=3)     
c     RANGE OF VALIDITY ! seems good to ~0.01% for z <= 1000.0

      real*4     aa(maxn,maxpar), propd(maxn,maxpar)
      real*4     dpropd(maxn,maxpar)
      real*4     aaB(maxn,maxpar),propdB(maxn,maxpar)
      real*4     daa(maxn,maxpar)
      real*4     par(3,maxpar)

      real*8     aa8(maxn,maxpar), propd8(maxn,maxpar) ! BFR 27/10/99
c     real*4     dpropd8(maxn,maxpar) ! BFR 27/10/99
      real*8     aaB8(maxn,maxpar),propdB8(maxn,maxpar) ! BFR 27/10/99
      real*8     daa8(maxn,maxpar) ! BFR 27/10/99

      integer*4  nzcalc,npar, ipar
      
      real*8     aamax,aamin
      real*8     kapp0,om0,cc_0d, dacalc, factor, adub, pd, zero
      real*8     theint
      real*8     pi ! added BFR 26/10/99
      parameter(pi=3.1415926535897932384626) ! added BFR 26/10/99

      logical    verbose

      common  /propd2comm/ aa,propd,dpropd,daa, nzcalc,par,ipar,npar,
     _     aaB,propdB

      verbose=.false. !.true. !

      if(verbose)print*,'ipar=',ipar

c     ---- 
      aamin=0.000002d0 !0.001 !0.00001 ! 0.001!
      aamax=1.0d0 
      if(verbose)print*,'propd2init: LIMITS are: aamin,aamax=',aamin,aamax

c     ---- h_conv = 1 kms^-1 Mpc^-1 * 3.1558e16 s Gyr^-1, 
c     i.e. converts conventional H_0 units to inverse Gigayears ----
      sec_Gyr= 3.1558e16        ! seconds per Gigayear
      akm_Mpc= 3.086e19   ! km per Megaparsec
      akG_sM = akm_Mpc/sec_Gyr ! km Gyr per sec Mpc

c     h_conv=1.024e-3  ! not used
      c=299792.4562
      
      zero=  1.0d-5 !-99.9  ! test only 

      if(verbose)print*,'propd2init: q_0,H_0,cc_0=',q_0,H_0,cc_0
      nzcalc= maxn/10
c      print*,'nzcalc=',nzcalc
c      write(6,'(a,$)')'Enter nzcalc: '
c      read(5,*)nzcalc
      if(verbose)print*,'nzcalc=',nzcalc

      dacalc=(aamax-aamin)/dble(nzcalc)
       if(verbose)print*,'dacalc=',dacalc
      theint=0.0d0
      cc_0d=dble(cc_0)
      om0= 2.0d0*(dble(q_0)+cc_0d)
      kapp0= om0 + cc_0d -1.0d0
      if(abs(kapp0).lt.zero)then
         factor=1.0d0
      else
         factor= sqrt(abs(kapp0))
      endif
       if(verbose)print*,'propd2init: om0,kapp0,factor=',
     _     om0,kapp0,factor
       if(verbose)print*,'cc_0d=',cc_0d

      do izcalc=nzcalc,1,-1
         adub= aamin+dacalc*(dble(izcalc  )-0.5d0)
         aa8(izcalc,ipar)= adub -dacalc*0.5d0 
         aa(izcalc,ipar)=real( adub -dacalc*0.5d0 )
         if(om0/adub -kapp0 +cc_0d*adub*adub .le.0.0)then
             print*,'propd2init Warning: '
             print*,om0/adub -kapp0 +cc_0d*adub*adub,' <= 0.'
         endif

         theint=theint+ 1.0/adub 
     _        /sqrt( om0/adub -kapp0 +cc_0d*adub*adub )
         pd =dacalc* theint           

         if(abs(kapp0).lt.zero)then
            propd(izcalc,ipar)= real( pd *c/H_0 )
            propd8(izcalc,ipar)=  pd *c/H_0 
         elseif(kapp0.le.-zero)then
            propd(izcalc,ipar)= sinh(factor*pd)/factor *c/H_0
            propd8(izcalc,ipar)= sinh(factor*pd)/factor *dble(c/H_0)
         else             ! if(kapp0.ge.zero)then
            propd(izcalc,ipar)= sin(factor*pd)/factor *c/H_0
            propd8(izcalc,ipar)= sin(factor*pd)/factor *dble(c/H_0)
         endif
      enddo
      call spline(aa(1,ipar),propd(1,ipar),nzcalc,0.0,0.0,
     _     dpropd(1,ipar))

      do i=1,nzcalc
         aaB(i,ipar)=aa(nzcalc+1-i,ipar)
         propdB(i,ipar)=propd(nzcalc+1-i,ipar)
         aaB8(i,ipar)=aa8(nzcalc+1-i,ipar)
         propdB8(i,ipar)=propd8(nzcalc+1-i,ipar)
      enddo

c      call spline(propdB(1,ipar),aaB(1,ipar),nzcalc,0.0,0.0, ! for inverse
c     _     daa(1,ipar))
      call spline8(propdB8(1,ipar),aaB8(1,ipar),nzcalc,0.0,0.0, ! for inverse
     _     daa8(1,ipar))

      do i=1,nzcalc
         daa(i,ipar)=real(daa8(i,ipar))
      enddo

c     ---- for testing....----
      jj=nzcalc/10
       if(verbose)print*,'jj=',jj
       if(verbose)print*,'(dpropd(jj*i,ipar),i=1,10)'
       if(verbose)print*,(dpropd(jj*i,ipar),i=1,10)
       if(verbose)print*,'(daa(jj*i,ipar),i=1,10)'
       if(verbose)print*,(daa(jj*i,ipar),i=1,10)
       if(verbose)print*,'(aa(jj*i,ipar),propd(jj*i,ipar),i=1,10)'
       if(verbose)print*,(aa(jj*i,ipar),propd(jj*i,ipar),i=1,10)

c      aa(1,ipar)=0.0
c      propd(1,ipar)= c * tofz2(q_0,H_0,cc_0,0.0)/akG_sM ! propd(z>>1) ->c t_0
c      print*,'propd(1,ipar)=',propd(1,ipar)
c      dpropd(1,ipar)= -9e9
c      daa(1,ipar)= 0.0

c      print*,'TESTTESTTEST'

c      do while(1+1.eq.2)
c         write(6,'(a,$)')'Enter a: '
c         read(5,*)a
c         call splint(aa(1,ipar),propd(1,ipar),dpropd(1,ipar),nzcalc,
c     _        a,pd)
c         print*,'a,pd=',a,pd
c      enddo

      return
      end


      function propd2(q_0,H_0,cc_0,z)
c     WARNING: propd2  is for the  proper motion distance 
c     (terminology Weinberg 1972), not the proper distance

c      parameter(maxn=100000,maxpar=3)     
      parameter(maxn=10000,maxpar=3)     
      real*4     q_0,H_0,cc_0,z
      real*4     aa(maxn,maxpar), propd(maxn,maxpar)
      real*4     dpropd(maxn,maxpar)
      real*4     aaB(maxn,maxpar),propdB(maxn,maxpar)
      real*4     daa(maxn,maxpar)
      real*4     par(3,maxpar), a !,t
      integer*4  nzcalc,ipar,npar, first
      logical*1  already, verbose

      common  /propd2comm/ aa,propd,dpropd,daa,nzcalc,par,ipar,npar,
     _     aaB,propdB
      save    already,first

      data first/0/

      verbose=.false. !.true. !

      if(first.ne.1234)then
         npar=0                 ! only set npar=0 very first time
         first=1234
      endif

      already=.false.
      if( (npar.gt.0).and.(npar.le.maxpar) )then
         ipar=0
         do while((ipar.lt.npar).and.(.not.(already)))
            ipar=ipar+1
            if( (par(1,ipar).eq.q_0).and.(par(2,ipar).eq.H_0)
     _           .and.(par(3,ipar).eq.cc_0) ) already=.true.
         enddo
      endif
      if(.not.(already))then
         if(verbose)print*,'inside not already loop: ipar=',ipar
         ipar=mod(npar+1  -1,maxpar)+1
         npar=ipar
         call propd2init(q_0,H_0,cc_0)
         par(1,ipar)=q_0
         par(2,ipar)=H_0
         par(3,ipar)=cc_0
      endif

      a= 1.0/(1.0+z)
      call splint(aa(1,ipar),propd(1,ipar),dpropd(1,ipar),nzcalc,a,pd)
      if(a.le.aa(1,ipar))then
         print*,'propd2 WARNING: z =',z,' too high.'
      elseif(a.gt.aa(nzcalc,ipar))then
         print*,'propd2 WARNING: z =',z,' is low. Physical meaning?'
         pd = z * 299792.0/H_0  ! H_0 in Mpc
      endif
      propd2= pd
      return
      end


      function zofpd2(q_0,H_0,cc_0,d)
c     ==== inverse of  propd2(q_0,H_0,cc_0,z) ====
c     WARNING: propd2  is for the  proper motion distance 
c     (terminology Weinberg 1972), not the proper distance

c      parameter(maxn=100000,maxpar=3)     
      parameter(maxn=10000,maxpar=3)     
      real*4     q_0,H_0,cc_0,d
      real*4     aa(maxn,maxpar), propd(maxn,maxpar)
      real*4     dpropd(maxn,maxpar)
      real*4     aaB(maxn,maxpar),propdB(maxn,maxpar)
      real*4     daa(maxn,maxpar)
      real*4     par(3,maxpar), a,z
      integer*4  nzcalc,ipar,npar, first
      logical*1  already

      common  /propd2comm/ aa,propd,dpropd,daa,nzcalc,par,ipar,npar,
     _     aaB,propdB
      save    already,first

      if(first.ne.1234)then
         npar=0                 ! only set npar=0 very first time
         first=1234
      endif

      already=.false.
      if( (npar.gt.0).and.(npar.le.maxpar) )then
         ipar=0
         do while((ipar.lt.npar).and.(.not.(already)))
            ipar=ipar+1
            if( (par(1,ipar).eq.q_0).and.(par(2,ipar).eq.H_0)
     _           .and.(par(3,ipar).eq.cc_0) ) already=.true.
         enddo
      endif
      if(.not.(already))then
         print*,'inside not already loop: ipar=',ipar
         ipar=mod(npar+1  -1,maxpar)+1
         npar=ipar
         call propd2init(q_0,H_0,cc_0)
         par(1,ipar)=q_0
         par(2,ipar)=H_0
         par(3,ipar)=cc_0
      endif

      call splint(propdB(1,ipar),aaB(1,ipar),daa(1,ipar),nzcalc,d,a)
      z= 1.0/a -1.0
      zofpd2= z
      if(d.lt.propd(nzcalc,ipar))then
         print*,'zofpd2 Warning: d=',d,' too small!'
      elseif(d.gt.propd(1,ipar))then
         print*,'zofpd2 Warning: d=',d,' too large!'
      endif

      return
      end

