c      program testd_l3
      subroutine testd_l3
c     - swap between commenting out the above two lines to 
c     use this as a test, standalone programme, or as a routine
c     to be called.

c     ==== these subroutines test, initialise, and 
c     spline-interpolate (via splint) in  the integral
c     to use for calculating  d_L(z)  (luminosity distance) 
c     for arbitrary 
c     omm, \lambda_0, H_0, w_q, z  
c     
c     omm = \Omega_{matter}, \lambda_0 = cc_0 = \Omega_q, w_q = w_q

c     units = Mpc

c     Note that cc_0 = \lambda_0 (cosm. const.) ====

c     ==== To get the plot, enter a value of omm > 99.9 
c     to the prompt (plus any other values for other parameters)
c     (or on a non-linux unix machine, you can use ^D ).
c     You will then be asked to put in some parameters 
c     to make a plot of the angular diameter of a galaxy
c     of fixed proper size displaced at different values
c     of the cosmological scale parameter a = 1/(1+z) .

      parameter(maxnout=5000)
      real*4    a(maxnout),z(maxnout)
      real*4    t1(maxnout),t2(maxnout)
      real*4    dprop1(maxnout),dprop2(maxnout)
      real*4    diff1(maxnout),diff2(maxnout)
      real*4    angdiam(maxnout)

c      real*4    aa(maxn),tt(maxn),dtt(maxn)
      logical   doprint
      parameter(pi=3.1415926536,c=299792.4562)

c      do while(1+1.eq.2.and.q_0.le.99.9) ! Enter q_0 .gt. 99.9 to terminate
      do while(1+1.eq.2.and.omm.le.99.9) ! Enter q_0 .gt. 99.9 to terminate
         print*,'omm,H_0,cc_0=',omm,H_0,cc_0
         write(6,'(a,$)')'Enter omm,H_0,cc_0,w_q,zz:' !,ttt: '
         read(5,*,end=555)omm,H_0,cc_0,w_q,zz !,ttt
         if(omm.le.99.9)then
            print*,'omm,H_0,cc_0,w_q,zz=',omm,H_0,cc_0,w_q,zz

            xx1=pmdist(omm,H_0,cc_0,w_q,zz)
            print*,'pmdist(omm,H_0,cc_0,zz),pmdist(.)*(1+zz)='
            print*,xx1,xx1*(1.0+zz)
            rr=2*c/H_0*(1.0-1.0/sqrt(1.0+ zz  )) !12000 Mpc=2c/H_0
            print*,'2*c/H_0*(1-1/sqrt(1+z))=',rr
            print*,'diff= ',rr-xx1
            zz=zofpdm(omm,H_0,cc_0,w_q,xx1)
            print*,'zofpdm(omm,H_0,cc_0,w_q,xx1)=',zz
            print*,' '
         endif
      enddo
 555  continue

c      call tofz2init(q_0,H_0,cc_0)

      zmin=1e-4 ! 0.001
      zmax=100.0
      nzout=3000

      call pgbegin(0,'?',1,1)
      write(6,'(a,$)')'Enter  ang. diam. max (arcsec): '
      read(5,*)admax
      print*,'zmin,zmax,nzout=',zmin,zmax,nzout
      write(6,'(a,$)')'Enter  zmin, zmax: '
      read(5,*)zmin, zmax
      aamin= 1.0/(1.0+zmax)
      print*,'aamin=',aamin
      write(6,'(a,$)')'Enter  aamin: '
      read(5,*)aamin

      dzout=(zmax-zmin)/real(nzout-1)

      do while(1+1.eq.2)
         amax=20.0
         print*,'omm,H_0,cc_0,w_q=',omm,H_0,cc_0,w_q
         write(6,'(a,$)')'Enter new values: '
         read(5,*,end=666)omm,H_0,cc_0,w_q
         
         write(6,'(a,$)')'Enter gal. size (kpc): '
         read(5,*,end=666)gsize

         doprint=.false.

         do izout=1,nzout
            if(doprint)print*,'izout=',izout,'...'
            z(izout)= zmin+ real(izout-1)*dzout
            a(izout)= 1.0/(1.0+z(izout))
            if(doprint)print*,'a(izout),z(izout)=',a(izout),z(izout)
c            t1(izout)=tofz3(q_0,H_0,cc_0,z(izout))

            dprop1(izout)=pmdist(omm,H_0,cc_0,w_q,z(izout))

            if(abs(w_q+1.0).lt.1e-2)then
c     !!!! following two lines require  d_l.f, tofz.f, for comparison !!!!
c               t3(izout)=tofz(q_0,H_0,z(izout))
c               dprop3(izout)=propdist(q_0,H_0,z(izout))
               q_0= omm/2.0 - cc_0  !! ?? is this correct for quintessence ???
               dprop2(izout)=propd2(q_0,H_0,cc_0,z(izout))
c               diff1(izout)=t1(izout)/t3(izout)
               diff2(izout)=dprop1(izout)/dprop2(izout)
c               if(doprint)print*,'diff1(izout)=',diff1(izout)
               if(doprint)print*,'ratio diff2(izout)=',diff2(izout)
            endif
            angdiam(izout)= gsize /1000.0
     _           / ( pmdist(omm,H_0,cc_0,w_q,z(izout)) 
     _           /(1.0+z(izout)) )
     _           /pi *180.0 *3600.0
         enddo

         dpropmax=12000.0
c         admax= 20.0

         call pgsch(0.8)
         call pgscf(2)
         call pgvsize(1.0,6.0,1.0,6.0)
c         call pgwindow(0.0,1.0,0.0,dpropmax)
         call pgwindow(aamin,1.0,0.0,admax)
         call pgbox('bcnts',0.,0,'bcnts',0.,0)
         call pgsch(1.0)
c         call pgline(nzout,a,dprop1)
         call pgline(nzout,a,angdiam)
         call pgsls(4)
c         if(cc_0.eq.0.0)call pgpoint(nzout,a,dprop2,5)
         call pgsls(1)
c         call pglabel('a','d\\dprop','integrations...')
         call pglabel('a','ang. diam (arc sec)','integrations...')

      enddo
 666  continue

      call pgend

      end


      subroutine pmdistinit(omm,H_0,cc_0,w_q)
c     ---- initialises table of integration for values of t ----
c     WARNING: pmdist  is for the  proper motion distance 
c     (terminology Weinberg 1972), not the proper distance

c     Brief description: a table is set up for each choice
c     of metric parameters, with a high number of points from
c     which to interpolate later on when called by either
c     pmdist  or  zofpd2 . Because the resolution is high 
c     to minimise numerical effects (no subtle applied maths
c     is used, this is just first principles integration - 
c     divide into equal intervals, and add up the histogram),
c     only a small number of  metric  choices is kept at a time.
c
c     So this algorithm is OK if you test a small number of
c     sets of  metric  parameters, but _inefficient_ if you 
c     want to plot, say, luminosity distance as a function
c     of \Omega_0, for 10000 different values of \Omega_0, 
c     and keeping  z  fixed - unless you set maxpar=10000
c     and reduce  maxn. In that case you should put in a 
c     better integration algorithm.

c     units = Mpc

      real*4     omm,H_0,cc_0,w_q
c      parameter(maxn=100000,maxpar=3)     
      parameter(maxn=10000,maxpar=3)     
c     RANGE OF VALIDITY ! seems good to ~0.01% for z <= 1000.0

      real*4     aa(maxn,maxpar), pmd(maxn,maxpar)
      real*4     dpmd(maxn,maxpar)
      real*4     aaB(maxn,maxpar),pmdB(maxn,maxpar)
      real*4     daa(maxn,maxpar)
      real*4     par(4,maxpar)

      real*8     aa8(maxn,maxpar), pmd8(maxn,maxpar) ! BFR 27/10/99
c     real*4     dpmd8(maxn,maxpar) ! BFR 27/10/99
      real*8     aaB8(maxn,maxpar),pmdB8(maxn,maxpar) ! BFR 27/10/99
      real*8     daa8(maxn,maxpar) ! BFR 27/10/99

      integer*4  nzcalc,npar, ipar
      
      real*8     aamax,aamin
      real*8     kapp0,ommd,cc_0d,w_qd
      real*8     dacalc, factor, adub, pd, zero,  w_qindex
      real*8     theint
      real*8     pi ! added BFR 26/10/99
      parameter(pi=3.1415926535897932384626) ! added BFR 26/10/99

      logical    verbose

      common  /pmdistcomm/ aa,pmd,dpmd,daa, nzcalc,par,ipar,npar,
     _     aaB,pmdB

      verbose=.false. !.true. !

      if(verbose)print*,'ipar=',ipar

c     ---- 
      aamin=0.000002d0 !0.001 !0.00001 ! 0.001!
      aamax=1.0d0 
      if(verbose)print*,'pmdistinit: LIMITS are: aamin,aamax=',aamin,aamax

c     ---- h_conv = 1 kms^-1 Mpc^-1 * 3.1558e16 s Gyr^-1, 
c     i.e. converts conventional H_0 units to inverse Gigayears ----
      sec_Gyr= 3.1558e16        ! seconds per Gigayear
      akm_Mpc= 3.086e19   ! km per Megaparsec
      akG_sM = akm_Mpc/sec_Gyr ! km Gyr per sec Mpc

c     h_conv=1.024e-3  ! not used
      c=299792.4562
      
      zero=  1.0d-5 !-99.9  ! test only 

      if(verbose)print*,'pmdistinit: omm,H_0,cc_0=',omm,H_0,cc_0
      nzcalc= maxn/10
c      print*,'nzcalc=',nzcalc
c      write(6,'(a,$)')'Enter nzcalc: '
c      read(5,*)nzcalc
      if(verbose)print*,'nzcalc=',nzcalc

      dacalc=(aamax-aamin)/dble(nzcalc)
       if(verbose)print*,'dacalc=',dacalc
      theint=0.0d0

      ommd=dble(omm)
      cc_0d=dble(cc_0)
c      om0= 2.0d0*(dble(q_0)+cc_0d)
      w_qd=dble(w_q)

      kapp0= ommd + cc_0d -1.0d0
      if(abs(kapp0).lt.zero)then
         factor=1.0d0
      else
         factor= sqrt(abs(kapp0))
      endif
      if(verbose)print*,'pmdistinit: ommd,kapp0,factor=',
     _     ommd,kapp0,factor
      if(verbose)print*,'cc_0d=',cc_0d
      
      w_qindex=  -(1.0d0+3.0d0*w_qd) ! \equiv -( 3.0d0* (1.0d0+w_qd) - 2.0d0 )

      do izcalc=nzcalc,1,-1
         adub= aamin+dacalc*(dble(izcalc  )-0.5d0)
         aa8(izcalc,ipar)= adub -dacalc*0.5d0 
         aa(izcalc,ipar)=real( adub -dacalc*0.5d0 )
         if(ommd/adub -kapp0 +cc_0d*adub*adub .le.0.0)then
             print*,'pmdistinit Warning: '
             print*,ommd/adub -kapp0 +cc_0d*adub*adub,' <= 0.'
         endif

         theint=theint+ 1.0/adub 
     _        /sqrt( ommd/adub -kapp0 
c     _        + cc_0d*adub*adub  !  non-quintessential version 
     _        + cc_0d* exp( log(adub)* w_qindex )  ) ! quintessence
         pd =dacalc* theint           

         if(abs(kapp0).lt.zero)then
            pmd(izcalc,ipar)= real( pd *c/H_0 )
            pmd8(izcalc,ipar)=  pd *c/H_0 
         elseif(kapp0.le.-zero)then
            pmd(izcalc,ipar)= sinh(factor*pd)/factor *c/H_0
            pmd8(izcalc,ipar)= sinh(factor*pd)/factor *dble(c/H_0)
         else             ! if(kapp0.ge.zero)then
            pmd(izcalc,ipar)= sin(factor*pd)/factor *c/H_0
            pmd8(izcalc,ipar)= sin(factor*pd)/factor *dble(c/H_0)
         endif
      enddo
      call spline(aa(1,ipar),pmd(1,ipar),nzcalc,0.0,0.0,
     _     dpmd(1,ipar))

      do i=1,nzcalc
         aaB(i,ipar)=aa(nzcalc+1-i,ipar)
         pmdB(i,ipar)=pmd(nzcalc+1-i,ipar)
         aaB8(i,ipar)=aa8(nzcalc+1-i,ipar)
         pmdB8(i,ipar)=pmd8(nzcalc+1-i,ipar)
      enddo

c      call spline(pmdB(1,ipar),aaB(1,ipar),nzcalc,0.0,0.0, ! for inverse
c     _     daa(1,ipar))
      call spline8(pmdB8(1,ipar),aaB8(1,ipar),nzcalc,0.0,0.0, ! for inverse
     _     daa8(1,ipar))

      do i=1,nzcalc
         daa(i,ipar)=real(daa8(i,ipar))
      enddo

c     ---- for testing....----
      jj=nzcalc/10
       if(verbose)print*,'jj=',jj
       if(verbose)print*,'(dpmd(jj*i,ipar),i=1,10)'
       if(verbose)print*,(dpmd(jj*i,ipar),i=1,10)
       if(verbose)print*,'(daa(jj*i,ipar),i=1,10)'
       if(verbose)print*,(daa(jj*i,ipar),i=1,10)
       if(verbose)print*,'(aa(jj*i,ipar),pmd(jj*i,ipar),i=1,10)'
       if(verbose)print*,(aa(jj*i,ipar),pmd(jj*i,ipar),i=1,10)

c      aa(1,ipar)=0.0
c      pmd(1,ipar)= c * tofz3(q_0,H_0,cc_0,0.0)/akG_sM ! pmd(z>>1) ->c t_0
c      print*,'pmd(1,ipar)=',pmd(1,ipar)
c      dpmd(1,ipar)= -9e9
c      daa(1,ipar)= 0.0

c      print*,'TESTTESTTEST'

c      do while(1+1.eq.2)
c         write(6,'(a,$)')'Enter a: '
c         read(5,*)a
c         call splint(aa(1,ipar),pmd(1,ipar),dpmd(1,ipar),nzcalc,
c     _        a,pd)
c         print*,'a,pd=',a,pd
c      enddo

      return
      end


      function pmdist(omm,H_0,cc_0,w_q,z)
c     WARNING: pmdist  is for the  proper motion distance 
c     (terminology Weinberg 1972), not the proper distance

c      parameter(maxn=100000,maxpar=3)     
      parameter(maxn=10000,maxpar=3)     
      real*4     omm,H_0,cc_0,w_q,z
      real*4     aa(maxn,maxpar), pmd(maxn,maxpar)
      real*4     dpmd(maxn,maxpar)
      real*4     aaB(maxn,maxpar),pmdB(maxn,maxpar)
      real*4     daa(maxn,maxpar)
      real*4     par(4,maxpar), a !,t
      integer*4  nzcalc,ipar,npar, first
      logical*1  already, verbose

      common  /pmdistcomm/ aa,pmd,dpmd,daa,nzcalc,par,ipar,npar,
     _     aaB,pmdB
      save    already,first

      data first/0/

      verbose=.false. !.true. !

      if(first.ne.1234)then
         npar=0                 ! only set npar=0 very first time
         first=1234
      endif

      already=.false.
      if( (npar.gt.0).and.(npar.le.maxpar) )then
         ipar=0
         do while((ipar.lt.npar).and.(.not.(already)))
            ipar=ipar+1
            if( (par(1,ipar).eq.omm).and.(par(2,ipar).eq.H_0)
     _           .and.(par(3,ipar).eq.cc_0) 
     _           .and.(par(4,ipar).eq.w_q) ) already=.true.
         enddo
      endif
      if(.not.(already))then
         if(verbose)print*,'inside not already loop: ipar=',ipar
         ipar=mod(npar+1  -1,maxpar)+1
         npar=ipar
         call pmdistinit(omm,H_0,cc_0,w_q)
         par(1,ipar)=omm
         par(2,ipar)=H_0
         par(3,ipar)=cc_0
         par(4,ipar)=w_q
      endif

      a= 1.0/(1.0+z)
      call splint(aa(1,ipar),pmd(1,ipar),dpmd(1,ipar),nzcalc,a,pd)
      if(a.le.aa(1,ipar))then
         print*,'pmdist WARNING: z =',z,' too high.'
      elseif(a.gt.aa(nzcalc,ipar))then
         print*,'pmdist WARNING: z =',z,' is low. Physical meaning?'
         pd = z * 299792.0/H_0  ! H_0 in Mpc
      endif
      pmdist= pd
      return
      end


      function zofpdm(omm,H_0,cc_0,w_q,d)
c     ==== inverse of  pmdist(omm,H_0,cc_0,w_q,z) ====
c     WARNING: pmdist  is for the  proper motion distance 
c     (terminology Weinberg 1972), not the proper distance

c      parameter(maxn=100000,maxpar=3)     
      parameter(maxn=10000,maxpar=3)     
      real*4     omm,H_0,cc_0,w_q,d
      real*4     aa(maxn,maxpar), pmd(maxn,maxpar)
      real*4     dpmd(maxn,maxpar)
      real*4     aaB(maxn,maxpar),pmdB(maxn,maxpar)
      real*4     daa(maxn,maxpar)
      real*4     par(4,maxpar), a,z
      integer*4  nzcalc,ipar,npar, first
      logical*1  already

      common  /pmdistcomm/ aa,pmd,dpmd,daa,nzcalc,par,ipar,npar,
     _     aaB,pmdB
      save    already,first

      if(first.ne.1234)then
         npar=0                 ! only set npar=0 very first time
         first=1234
      endif

      already=.false.
      if( (npar.gt.0).and.(npar.le.maxpar) )then
         ipar=0
         do while((ipar.lt.npar).and.(.not.(already)))
            ipar=ipar+1
            if( (par(1,ipar).eq.omm).and.(par(2,ipar).eq.H_0)
     _           .and.(par(3,ipar).eq.cc_0) 
     _           .and.(par(3,ipar).eq.w_q) ) already=.true.
         enddo
      endif
      if(.not.(already))then
         print*,'inside not already loop: ipar=',ipar
         ipar=mod(npar+1  -1,maxpar)+1
         npar=ipar
         call pmdistinit(omm,H_0,cc_0,w_q)
         par(1,ipar)=omm
         par(2,ipar)=H_0
         par(3,ipar)=cc_0
         par(4,ipar)=w_q
      endif

      call splint(pmdB(1,ipar),aaB(1,ipar),daa(1,ipar),nzcalc,d,a)
      z= 1.0/a -1.0
      zofpdm= z
      if(d.lt.pmd(nzcalc,ipar))then
         print*,'zofpdm Warning: d=',d,' too small!'
      elseif(d.gt.pmd(1,ipar))then
         print*,'zofpdm Warning: d=',d,' too large!'
      endif

      return
      end

