c      program pdWeiqtest
      subroutine pdWeiqtest
c     - swap between commenting out the above two lines to 
c     use this as a test, standalone programme, or as a routine
c     to be called.

c     proper distance, as per Weinberg (1972).

      real*4     omm,H_0,cc_0,w_q

      do while(1+1.eq.2)
      write(6,'(a,$)')'Enter omm, H_0, cc_0, w_q, z: '
      read(5,*)omm,H_0,cc_0,w_q, z
      print*,omm,H_0,cc_0,w_q, z

      pdW= pdWeiq(omm,H_0,cc_0,w_q,z)
      print*,'pdW= ',pdW
      dpm2= pmdist(omm,H_0,cc_0,w_q,z)
      print*,'dpm2= ',dpm2

      zW= z_pdWq(omm,H_0,cc_0,w_q, pdW)
      print*,' zW=', zW

      a= arcl_q(omm,H_0,cc_0,w_q, z)
      print*,'arcl_q  a=',a
      zarc= zofarq(omm,H_0,cc_0,w_q, a)
      print*,'zofarq  zarc=',zarc


      enddo

      end


      real*4 function pdWeiq(omm,H_0,cc_0,w_q,z)
c     proper distance, as per Weiqberg (1972).

c      real*8     kapp0,om0,cc_0d, factor, d, zero, c
      real*8     kapp0,ommd,cc_0d, w_qd, factor, d, zero, c
      real*8     rcurv

      logical    verbose

      parameter(c=299792.4562)
      parameter(zero=  1.0d-5)
      
      verbose=.false.

      ommd=dble(omm)
      cc_0d=dble(cc_0)
c      om0= 2.0d0*(dble(q_0)+cc_0d)
      w_qd=dble(w_q)
      kapp0= ommd + cc_0d -1.0d0

      d= dble(pmdist(omm,H_0,cc_0,w_q,z))

      if(abs(kapp0).lt.zero)then
         pdWeiq= real(d)
         return
c         factor=1.0d0
      else
         factor= sqrt(abs(kapp0))
      endif
      if(verbose)print*,'pdWeiq: om0,kapp0,factor=',om0,kapp0,factor
      if(verbose)print*,'cc_0d=',cc_0d
      
      rcurv= c/factor /dble(H_0)
      if(verbose)print*,'Rcurv=',rcurv
      
      d= d / rcurv

      if(kapp0.le.-zero)then
         d= log( d + sqrt(d*d +1.0d0) ) ! d= asinh( d )
      elseif(kapp0.gt.zero)then
         if(d.lt.zero.or.d.gt.1.0d0+zero)then
            print*,'pdWeiq Warning: d =',d,' out of range!'
            d=max(min(0.99999d0,d),0.00001d0)
         endif
         if(d.gt.1.0d0)d= min(0.99999d0,d)
         d= asin( d )
      endif
      d= rcurv * d
      
      pdWeiq= real(d)
      return
      end
      

      real*4 function z_pdWq(omm,H_0,cc_0,w_q,dp)
c     ==== for a given proper distance (Weinberg 1972), find z ====
c     i.e., inverse of  pdWeiq(...)

      real*4 omm,H_0,cc_0,w_q,dp !inputs

      real*8     kapp0,om0,cc_0d, factor, d, zero, c !internal
      real*8     rcurv          !internal
      real*4     d4

      logical    verbose

      parameter(c=299792.4562)
      parameter(zero=  1.0d-5)
      
      verbose=.false.

      ommd=dble(omm)
      cc_0d=dble(cc_0)
c      om0= 2.0d0*(dble(q_0)+cc_0d)
      w_qd=dble(w_q)

      kapp0= ommd + cc_0d -1.0d0

      if(abs(kapp0).lt.zero)then
         z_pdWq= zofpdm(omm,H_0,cc_0,w_q, dp)
         return
c         factor=1.0d0
      else
         factor= sqrt(abs(kapp0))
      endif
      if(verbose)print*,'z_pdWq: ommd,kapp0,factor=',ommm,kapp0,factor
      if(verbose)print*,'cc_0d=',cc_0d
      
      rcurv= c/factor /dble(H_0)
      if(verbose)print*,'Rcurv=',rcurv
      
      d= dble(dp) /rcurv ! proper dist in units of R_C

c     -- convert to proper motion distance, i.e. propd2( )
      if(kapp0.le.-zero)then
         d= (exp(d) -exp(-d) )/2.0d0 ! d= sinh( d )
      elseif(kapp0.gt.zero)then
         d= sin( d )
      endif
      d= rcurv * d
      d4=real(d)

      z_pdWq= zofpdm(omm,H_0,cc_0,w_q, d4)
      return
      end



      function arcl_q(omm,H0,cc0,w_q,z)
c     --- length along arc of 1 radian in comoving, proper distance units ---
      dd= pdWeiq(om,H0,cc0,w_q,z)
      tol=1e-5
c      curv0= 2.0*q0+3.0*cc0 -1.0
      curv0= omm+cc0-1.0
      if(curv0.lt.-tol)then !  hyperbolic
         rC= 3000.0 *(100.0/H0) /sqrt( - curv0 )
         arcl_q= rC* (exp(dd/rC) - exp(-dd/rC))/2.0
      elseif(curv0.gt.-tol .and. curv0.lt.tol)then
         arcl_q =  dd 
      else
         rC= 3000.0 *(100.0/H0)  /sqrt( curv0 )
         arcl_q = rC*sin(dd/rC)
      endif
      return
      end


      function zofarq(omm,H0,cc0,w_q,arc)
c     --- redshift at which arclength  arc = 1 radian in comov. prop dist ---
      tol=1e-5
      tol_sin= 1e-5

c      curv0= 2.0*q0+3.0*cc0 -1.0
      curv0= omm+cc0-1.0
      if(curv0.lt.-tol)then !  hyperbolic      
         rC= 3000.0 *(100.0/H0) /sqrt( - curv0 )
         arcC = arc/rC
         dd= rC * log(arcC + sqrt(arcC*arcC +1.0))
         zofarq = z_pdWq(omm,H0,cc0,w_q, dd)
      elseif(curv0.gt.-tol .and. curv0.lt.tol)then
         zofarq = z_pdWq(omm,H0,cc0,w_q, arc)
      else
c     !       arc/rC < pi/2 ! !
         rC= 3000.0 *(100.0/H0) /sqrt( curv0 )
         arcC = arc/rC
         if(arcC.gt.1.0)then
            print*,'zofarq Warning: arcC too big ! '
            print*,'omm,H0,cc0,w_q,arc, rC =',omm,H0,cc0,w_q,arc, rC 
            arcC = 1.0 - tol_sin
         endif
         dd = rC * asin(arcC)
         zofarq = z_pdWq(omm,H0,cc0,w_q, dd)
      endif
      return
      end
