c      program testschech
      subroutine testschech
c     ==== plots Schechter function ====
      parameter(nmag=100)
      real*4   m1,m2,mags(nmag),phistar,mstar,alpha,phi(nmag)
      character*10   band
      character      ch

      H_0=50.0
      phistar=1.95e-3
      mstar=-21.1
      alpha=-1.1
      band='B\\dJ'
      do while(1+1.eq.2)
         print*,'Enter m1,m2,phi1,phi2 (Ctrl<D> to stop):'
         read(5,*,end=77)m1,m2,phi1,phi2
         
         print*,'H_0, phistar, mstar, alpha= ',H_0,phistar,mstar,alpha
         write(6,'(a,$)')'Change Schechter parameters? [N] '
         read(5,'(a)')ch
         if((ch.eq.'y').or.(ch.eq.'Y'))then
            write(6,'(a,$)')'Enter H_0, phistar, mstar, alpha: '
            read(5,*)H_0, phistar, mstar, alpha
         endif

         delm=(m2-m1)/real(nmag)
         do i=1,nmag
            mags(i)= m1+(real(i)-0.5)*delm
            phi(i)=log10(schech(mags(i),H_0,phistar,mstar,alpha))
         enddo
         
         call pgbegin(0,'?',1,1)
         call pgscf(2)
         call pgvsize(1.0,7.0,1.0,7.0)
         call pgwindow(m1,m2,phi1,phi2)
         call pgbox('bcnts',0.,0,'bcntsv',0.,0)
         call pglabel(band,'log\\d10\\u(N in Mpc\\u-3\\d mag\\u-1\\d)',
     _        'Schechter Luminosity Function (z=0)')
         call pgline(nmag,mags,phi)
c         call pgiden
         call pgend
      enddo
 77   continue
      
      end






      function schech(m,H_0,phistar,mstar,alpha)
c     ==== calculates Schechter luminosity function (default) ====
      real*4     schech,m,H_0,phistar,mstar,alpha,phist2,mst2

      phist2=phistar *(H_0*H_0*H_0)/(50.0*50.0*50.0)
      mst2=mstar -5.0*log10(50.0/H_0)

      schech= 0.92* phist2 *exp(-0.92*(alpha+1.0)*( m -mst2)
     _     -exp(-0.92*( m -mst2)))

      return
      end

