c      program testtofz2
      subroutine testtofz2
c     ==== these subroutines test, initialise, and 
c     spline-interpolate (via splint) in  the two integrals  
c     to use for calculating  t(z) and d_L(z) for arbitrary 
c     q_0, \lambda_0, H_0, z  
c     Note that cc_0 = \lambda_0 (cosm. const.) ====

      parameter(maxnout=100)
      real*4    a(maxnout),z(maxnout)
      real*4    t1(maxnout),t2(maxnout)
      real*4    d_L1(maxnout),d_L2(maxnout)
      real*4    diff1(maxnout),diff2(maxnout)

c      real*4    aa(maxn),tt(maxn),dtt(maxn)

      zmin=0.001
      zmax=10.0
      nzout=50
      dzout=(zmax-zmin)/real(nzout-1)

      do while(1+1.eq.2.and.q_0.le.99.9) ! q_0 .gt. 99.9 to end loop
         print*,'q_0,H_0,cc_0=',q_0,H_0,cc_0
         write(6,'(a,$)')'Enter q_0,H_0,cc_0,zz,ttt: '
         read(5,*,end=555)q_0,H_0,cc_0,zz,ttt
         if(q_0.le.99.9)then
            print*,'q_0,H_0,cc_0,zz,ttt=',q_0,H_0,cc_0,zz,ttt
            xx=tofz2(q_0,H_0,cc_0,zz)
            yy=zoft2(q_0,H_0,cc_0,ttt)
            print*,'tofz2(q_0,H_0,cc_0,zz), zoft2(q_0,H_0,cc_0,ttt)='
            print*,xx,yy
         endif
      enddo
 555  continue

c      call tofz2init(q_0,H_0,cc_0)

      call pgbegin(0,'?',1,1)
      do while(1+1.eq.2)
         amax=20.0
         print*,'q_0,H_0,cc_0=',q_0,H_0,cc_0
         write(6,'(a,$)')'Enter new values: '
         read(5,*,end=666)q_0,H_0,cc_0

         do izout=1,nzout
            print*,'izout=',izout,'...'
            z(izout)= zmin+ real(izout-1)*dzout
            a(izout)= 1.0/(1.0+z(izout))
            print*,'a(izout),z(izout)=',a(izout),z(izout)
            t1(izout)=tofz2(q_0,H_0,cc_0,z(izout))
            
c            if(cc_0.eq.0.0)then
c               t2(izout)=tofz(q_0,H_0,z(izout))  !!! requires tofz( )
c               diff1(izout)=t1(izout)/t2(izout)
c               print*,'diff1(izout)=',diff1(izout)
c            endif
         enddo

         call pgsch(0.8)
         call pgscf(2)
         call pgvsize(1.0,6.0,1.0,6.0)
         call pgwindow(0.0,amax,0.0,1.0)
         call pgbox('bcnts',0.,0,'bcnts',0.,0)
         call pgsch(1.0)
         call pgline(nzout,t1,a)
         call pgsls(4)
         if(cc_0.eq.0.0)call pgline(nzout,t2,a)
         call pgsls(1)
         call pglabel('t','a','integrations...')

      enddo
 666  continue

      call pgend

      end


      subroutine tofz2init(q_0,H_0,cc_0)
c     ---- initialises table of integration for values of t ----

      real*4     q_0,H_0,cc_0
      parameter(maxn=10000,maxpar=10)     
c     RANGE OF VALIDITY ! seems good to ~0.1% for z <= 10.0, ~10% for z~ 1000.0
      real*4     aa(maxn,maxpar), tt(maxn,maxpar),dtt(maxn,maxpar)
      real*4     daa(maxn,maxpar)
      real*4     par(3,maxpar), a
      integer*4  nzcalc,npar, ipar

      common  /tofz2comm/ aa,tt,dtt,daa, nzcalc,par,ipar,npar

      print*,'ipar=',ipar

      aamin=0.00001 ! 0.001!
      aamax=1.0-0.0001
c     ---- h_conv = 1 kms^-1 Mpc^-1 * 3.1558e16 s Gyr^-1, 
c     i.e. converts conventional H_0 units to inverse Gigayears ----

      h_conv=1.024e-3

      print*,'tofz2init: q_0,H_0,cc_0=',q_0,H_0,cc_0
      nzcalc= 9999  !10000 !
c      print*,'nzcalc=',nzcalc
c      write(6,'(a,$)')'Enter nzcalc: '
c      read(5,*)nzcalc
      print*,'nzcalc=',nzcalc

      dacalc=(aamax-aamin)/real(nzcalc)
      print*,'dacalc=',dacalc
      theint=0.0
      om0= 2.0*(q_0+cc_0)
      do izcalc=2,nzcalc+1
         a= aamin+dacalc*(real(izcalc -1 )-0.5)
         aa(izcalc,ipar)=a
         theint=theint+ 1.0/sqrt(om0/a -om0-cc_0  +1.0 +cc_0*a*a)
         tt(izcalc,ipar)=dacalc* theint/H_0/h_conv 
      enddo
      call spline(aa(2,ipar),tt(2,ipar),nzcalc,0.0,0.0,
     _     dtt(2,ipar))
      call spline(tt(2,ipar),aa(2,ipar),nzcalc,0.0,0.0,
     _     daa(2,ipar))

      nzcalc=nzcalc+1
      aa(1,ipar)=0.0
      tt(1,ipar)=0.0
      dtt(1,ipar)= 0.0
      daa(1,ipar)= 9e9
      return
      end


      function tofz2(q_0,H_0,cc_0,z)
      parameter(maxn=10000,maxpar=10)     
      real*4     q_0,H_0,cc_0,z
      real*4     aa(maxn,maxpar), tt(maxn,maxpar),dtt(maxn,maxpar)
      real*4     daa(maxn,maxpar)
      real*4     par(3,maxpar), a,t
      integer*4  nzcalc,ipar,npar, first
      logical*1  already

      common  /tofz2comm/ aa,tt,dtt,daa,nzcalc,par,ipar,npar
      save    already,first

      if(first.ne.1234)then
         npar=0                 ! only set npar=0 very first time
         first=1234
      endif

      already=.false.
      if( (npar.gt.0).and.(npar.le.maxpar) )then
         ipar=0
         do while((ipar.lt.npar).and.(.not.(already)))
            ipar=ipar+1
            if( (par(1,ipar).eq.q_0).and.(par(2,ipar).eq.H_0)
     _           .and.(par(3,ipar).eq.cc_0) ) already=.true.
         enddo
      endif
      if(.not.(already))then
         print*,'inside not already loop: ipar=',ipar
         ipar=mod(npar+1  -1,maxpar)+1
         npar=ipar
         call tofz2init(q_0,H_0,cc_0)
         par(1,ipar)=q_0
         par(2,ipar)=H_0
         par(3,ipar)=cc_0
      endif

      a= 1.0/(1.0+z)
      call splint(aa(1,ipar),tt(1,ipar),dtt(1,ipar),nzcalc,a,t)
      tofz2= t
      return
      end


      function zoft2(q_0,H_0,cc_0,t)
      parameter(maxn=10000,maxpar=10)     
      real*4     q_0,H_0,cc_0,t
      real*4     aa(maxn,maxpar), tt(maxn,maxpar),dtt(maxn,maxpar)
      real*4     daa(maxn,maxpar)
      real*4     par(3,maxpar), a,z,  t_0
      integer*4  nzcalc,ipar,npar, first
      logical*1  already

      common  /tofz2comm/ aa,tt,dtt,daa,nzcalc,par,ipar,npar
      save    already,first,t_0

      if(first.ne.1234)then
         npar=0                 ! only set npar=0 very first time
         first=1234
      endif

      already=.false.
      if( (npar.gt.0).and.(npar.le.maxpar) )then
         ipar=0
         do while((ipar.lt.npar).and.(.not.(already)))
            ipar=ipar+1
            if( (par(1,ipar).eq.q_0).and.(par(2,ipar).eq.H_0)
     _           .and.(par(3,ipar).eq.cc_0) ) already=.true.
         enddo
      endif
      if(.not.(already))then
         print*,'inside not already loop: ipar=',ipar
         ipar=mod(npar+1  -1,maxpar)+1
         npar=ipar
         call tofz2init(q_0,H_0,cc_0)
         t_0 = tofz2(q_0,H_0,cc_0,0.0)
         par(1,ipar)=q_0
         par(2,ipar)=H_0
         par(3,ipar)=cc_0
      endif


      if(t.lt.t_0)then
         call splint(tt(1,ipar),aa(1,ipar),daa(1,ipar),nzcalc,t,a)
         z= 1.0/a -1.0
         zoft2= z
      elseif(t.eq.t_0)then
         zoft2= 0.0   
      else
         zoft2= 1e19            ! t>t_0;  this is an out-of-range marker
      endif

      return
      end

