c     ==== routines relating redshift  z  and cosmological time  t ====

c     H_0  to be in units of  kms^-1 Mpc^-1 

      subroutine testzt
c      program testzt
c     ==== tests the routines below ====
      parameter(n=20)
      real*4     a(n),t(n),aamax
      character  ch,ch10*10,ch5*5, ch6*6,ch15*15

      do while(1+1.eq.2)
         write(6,'(a,$)')'q_0,H_0,z,t1=? '
         read(5,*,end=777)q_0,H_0,z,t1
         write(6,'(a,$)')'q_0,H_0,z,tofz(q_0,H_0,z),zoft(q_0,H_0,t1)='
         print*,q_0,H_0,z,tofz(q_0,H_0,z), zoft(q_0,H_0,t1)
         print*,' '
      enddo
 777  continue

      write(6,'(a,$)')'Device type? '
      read(5,'(a5)')ch5

      call pgbegin(0,ch5,1,1)
      call pgscf(2)
c      call pgvsize(1.0,5.0,1.0,4.0)
      call pgvsize(1.0,8.0,1.0,6.0)

      write(6,'(a,$)')'tmax,aamax? '
      read(5,*)tmax,aamax
      print*,tmax,aamax

c      aamax=0.1

      call pgwindow(0.0,tmax,0.0,aamax)
      call pgsch(0.8)
      call pgbox('bcnts',0.0,0,'bntsv',0.,0)
      call pgmtext('r',4.0,0.5,0.5,'redshift')
      call pgbox('',0.0,0,'c',0.,0)
      call pgsch(1.0)

      call pglabel('time in Gyr','scale factor  a(t)',
     _     'Expansion of universe')
      ch='y'
      iplot=-1
      do while((ch.eq.'y').or.(ch.eq.'Y'))
         write(6,'(a,$)')'q_0,H_0,cc_0? '
         read(5,*)q_0,H_0,cc_0
         print*,q_0,H_0,cc_0
         
         dt=tmax/real(n)
         itmax=n
         do i=1,n
            t(i)=(real(i)-0.5)*dt
c            a(i)=1.0/(1.0+zoft(q_0,H_0,t(i)))
            a(i)=1.0/(1.0+zoft2(q_0,H_0,cc_0,t(i)))
            print*,t(i),a(i)
            if((a(i).le.1e-18).and.(itmax.eq.n))itmax=i
            print*,'itmax for plot is: ',itmax

            if((a(i).le.aamax).and.(iplot.eq.-1))then
               write(ch6,'(f6.2)')(1.0/a(i) -1.0)
               call pgtext(tmax,a(i),ch6)
            endif
         enddo
      
         call pgline(itmax,t,a)

         da=aamax/real(n)
         do i=1,n
            a(i)=(real(i)-0.5)*da
            z=1.0/a(i) -1.0
c            t(i)=tofz(q_0,H_0,z)
            t(i)=tofz2(q_0,H_0,cc_0,z)
            print*,t(i),a(i)
         enddo
         call pgpoint(n,t,a,4)

         write(6,'(a,$)')'Do you want labels? [Y] '
         read(5,'(a)')ch
         if((ch.ne.'n').and.(ch.ne.'N'))then
            print*,'Indicate on plot point at which to label q_0, H_0'
            
            if((ch5.ne.'/ps  ').and.(ch5.ne.'/vps '))
     _           call pgcurse(xx,yy,ch)

            ch10(1:10)='    ,     '
            if(q_0.ge.10.0)then
               write(ch10(1:4),'(f4.1)')q_0
            elseif(q_0.ge.0.1)then
               write(ch10(2:4),'(f3.1)')q_0
            elseif(q_0.ge.0.01)then
               write(ch10(1:4),'(f4.2)')q_0
            elseif(q_0.ge.0.001)then
               write(ch10(1:5),'(f5.3)')q_0
            elseif(q_0.lt.0.0)then
               write(ch10(1:5),'(f5.2)')q_0
               ch10(6:6)=','
            else
               write(ch10(1:5),'(e5.0)')q_0
            endif

            iplot=iplot+1
c            write(ch10(6:9),'(i4)')nint(H_0)
            write(ch10(7:10),'(i4)')nint(H_0)
            ch15=ch10//'     '
            write(ch15(11:15),'(f5.2)')cc_0

c            if(ch5.eq.'/ps  ')then
c               xx=t(n-iplot/4-1)-0.3*tmax/20.0
c               yy=a(n-iplot/4-1)
c            endif

            call pgsch(0.8)
            call pgptext(xx,yy,0.0,0.5,ch15)
            call pgsch(1.0)
         endif
         

         write(6,'(a,$)')'More curves? [N] '
         read(5,'(a)')ch
      enddo
      call pgiden
      call pgend

      end
         


      function tofz(q_0,H_0,z)
c     ==== calculates cosm. time  t  in Gyr from redshift  z  ====
      real*4     tofz, q_0,H_0, z,eta, aa,b
      real*4     h_conv
      real*4     curv
      integer*4  ihwarn,izwarn

      if(((ihwarn.lt.0).or.(ihwarn.gt.10)).and.(ihwarn.ne.999))ihwarn=0
      if(((izwarn.lt.0).or.(izwarn.gt.10)).and.(izwarn.ne.999))izwarn=0

      if(q_0.lt.0.0)print*,'zoft error: q_0=',q_0
      if(((H_0.lt.20.0).or.(H_0.gt.120.0)).and.(ihwarn.lt.10))then
         if(ihwarn.ne.999)ihwarn=ihwarn+1
         print*,
     _     'tofz warning: H_0 =',H_0,' kms^-1 Mpc^-1 is very unusual!!!'
      endif
      if(((z.lt.0.0).or.(z.gt.10000.0)).and.(izwarn.lt.10))then
         print*,
     _     'tofz warning: z=',z,' is very unusual!!!'
         if(izwarn.ne.999)izwarn=izwarn+1
      endif

      if(ihwarn.eq.10)then
         print*,'H_0 warning limit reached'
         ihwarn=999
      endif
      if(izwarn.eq.10)then
         print*,'z warning limit reached'
         izwarn=999
      endif

c     ---- h_conv = 1 kms^-1 Mpc^-1 * 3.1558e16 s Gyr^-1, 
c     i.e. converts conventional H_0 units to inverse Gigayears ----

      h_conv=1.024e-3

      if(q_0.eq.0.5)then
         t0=2.0/(3.0 *H_0 *h_conv)
         tofz=t0/(1.0+z) /sqrt(1.0+z)
      else
         aa= q_0 /(2.0*q_0 -1.0)
         if(aa.eq.0.0)then
            curv=0.0
         elseif(aa.lt.0.0)then
            curv=-1.0
         elseif(aa.gt.0.0)then
            curv=+1.0
         else
            print*,'Disaster: the ordering of the rationals has'
     _           ,'just collapsed !!!!!!!!!!!'
         endif
         
         aa=abs(aa)
         b=aa / (H_0*h_conv) /sqrt( abs(2.0*q_0 -1.0))
         
         if(curv.eq.1.0)then
            eta=acos(1.0- 1.0/(1.0+z)/aa)
            tofz=b* (eta -sin(eta))
         elseif(curv.eq.-1.0)then
            x=1.0/(1.0+z)/aa +1.0
            eta=log( x + sqrt(x*x -1.0))
            tofz= b* (sinh(eta)-eta)
         endif
      endif
      return
      end


      function zoft(q_0,H_0,t)
c     ==== calculates redshift  z  from  cosm. time  t  in Gyr   ====
      real*4     zoft, q_0,H_0, a,eta, aa,b
      real*4     h_conv
      real*4     curv
      integer*4  ihwarn,itwarn
      
      common /cosvars/ b

      if(((ihwarn.lt.0).or.(ihwarn.gt.10)).and.(ihwarn.ne.999))ihwarn=0
      if(((itwarn.lt.0).or.(itwarn.gt.10)).and.(itwarn.ne.999))itwarn=0

      if(q_0.lt.0.0)print*,'zoft error: q_0=',q_0
      if(((H_0.lt.20.0).or.(H_0.gt.120.0)).and.(ihwarn.lt.10))then
         if(ihwarn.ne.999)ihwarn=ihwarn+1
         print*,
     _     'zoft warning: H_0 =',H_0,' kms^-1 Mpc^-1 is very unusual!!!'
      endif
      if(((t.le.0.0).or.(t.gt.50.0)).and.(itwarn.lt.10))then
         if(itwarn.ne.999)itwarn=itwarn+1
         print*,
     _     'zoft warning: t=',t,' Gyr is very unusual!!!'
      endif
      if(ihwarn.eq.10)then
         print*,'H_0 warning limit reached.'
         ihwarn=999
      endif
      if(itwarn.eq.10)then
         print*,'t warning limit reached.'
         itwarn=999
      endif

c     ---- h_conv = 1 kms^-1 Mpc^-1 * 3.1558e16 s Gyr^-1, 
c     i.e. converts conventional H_0 units to inverse Gigayears ----

      h_conv=1.024e-3

      if(q_0.eq.0.5)then
         t0=2.0/(3.0 *H_0 *h_conv)
         a=exp((2.0/3.0)*log(t/t0))
         zoft=1.0/a -1.0
      else
         
         aa= q_0 /(2.0*q_0 -1.0)
         if(aa.eq.0.0)then
            curv=0.0
         elseif(aa.lt.0.0)then
            curv=-1.0
         elseif(aa.gt.0.0)then
            curv=+1.0
         else
            print*,'Disaster: the ordering of the rationals has'
     _           ,'just collapsed !!!!!!!!!!!'
         endif
         
         aa=abs(aa)
         b=aa / (H_0*h_conv) /sqrt( abs(2.0*q_0 -1.0))
         
         if(curv.eq.1.0)then
            eta1=0.0
            eta2=3.1415926536
            eta=eta2/2.0
            t1=tofetacl(eta1)
            t2=tofetacl(eta2)
            tt=tofetacl(eta)
            i=1
            do while(abs(tt-t)/t.ge.1e-5)
               i=i+1
               if(tt.gt.t)then
                  eta2=eta
                  t2=tt
               else
                  eta1=eta
                  t1=tt
               endif
               eta= eta1 + (t-t1)/(t2-t1) *(eta2-eta1)
               tt=tofetacl(eta)   
            enddo
            a=aa* (1.0 - cos(eta))
            zoft=1.0/a -1.0
         elseif(curv.eq.-1.0)then
            eta1=0.0
            x=t/b
            eta=log(x+sqrt(x*x+1.0))
            if(eta.gt.1.0)then
               eta2=eta+2.0
            else
               eta2=3.0
            endif

            t1=tofetaop(eta1)
            t2=tofetaop(eta2)
            tt=tofetaop(eta)
            i=1
            do while((abs(tt-t)/t.ge.1e-5).and.(i.lt.100))
               i=i+1
               if(tt.gt.t)then
                  eta2=eta
                  t2=tt
               else
                  eta1=eta
                  t1=tt
               endif
c               eta= eta1 + (t-t1)/(t2-t1) *(eta2-eta1)
               eta=0.5*(eta1+eta2)
               tt=tofetaop(eta)   
            enddo
            if(i.eq.100)print*,'zoft warning: i=100, tt,t=',tt,t
            a=aa*(cosh(eta)-1.0)
            zoft=1.0/a -1.0
         endif
      endif
      return
      end

      function tofetacl(eta)
c     ==== uses parameter eta ====
      real*4     tofetacl,b,eta
      common /cosvars/ b

      tofetacl=b*(eta-sin(eta))
      return
      end

      function tofetaop(eta)
c     ==== uses parameter eta ====
      real*4     tofetaop,b,eta
      common /cosvars/ b

      tofetaop=b*(sinh(eta)-eta)
      return
      end


      
